/* SCCS  %W--- %G% -- %U% */
//
// Vlayer
//
//////////////////////////////////////////////////////////////////////

/*********************************/
/*                               */
/*   Importing all Nsl classes   */
/*                               */
/*********************************/

import nslj.src.system.*;
import nslj.src.cmd.*;
import nslj.src.lang.*;
import nslj.src.math.*;
import nslj.src.display.*;

/*********************************/

public class Vlayer extends NslModule {

    // ports 
    public  NslDinDouble1 u_in; // will look for u_in
    public  NslDoutDouble0 vf;  // output port

    // variables
    private  NslDouble0 vp;  // neuron potential
    private  NslDouble0 h2;
    private double tau;         // time constant

    public void initRun(){
	vf.set(0);
	vp.set(0);
	tau=1.0;
	h2.set(  0.5);
    }

    public void simRun(){
	// vp=vp+((timestep/tv)*dv/dt)
	vp.set(  system.nsldiff.eval(vp, tau, __temp2.setReference(__temp1.setReference(__temp0.setReference(-vp.get()).get()+NslSum.eval(u_in)).get()-h2.get())));
	vf.set(  NslRamp.eval(vp));
    }

	/******************************************************/
	/*                                                    */
	/* Generated by NslCompiler. Do not edit these lines! */
	/*                                                    */
	/******************************************************/

	/* Constructor and related methods */
	/* makeinst() declared variables */

	/* Formal parameters */

	/* Temporary variables */
		NslDouble0 __temp0 = new NslDouble0();
		NslDouble0 __temp1 = new NslDouble0();
		NslDouble0 __temp2 = new NslDouble0();

	/* GENERIC CONSTRUCTOR: */
	public Vlayer(String nslName, NslModule nslParent) {
		super(nslName, nslParent);
		initSys();
		makeInst(nslName, nslParent);
	}

	public void makeInst(String nslName, NslModule nslParent) { 
		callFromConstructorTop();
		u_in = new NslDinDouble1("u_in", this);
		vf = new NslDoutDouble0("vf", this);
		vp = new NslDouble0("vp", this);
		h2 = new NslDouble0("h2", this);
		callFromConstructorBottom();
	}

	/******************************************************/
	/*                                                    */
	/* End of automatic declaration statements.           */
	/*                                                    */
	/******************************************************/


}

